//****************************************************************************
//**
//**    mMatrix.cpp
//**    Implementation for mMatrix.
//**    (C) 2000 - Douglas H. Cox
//**
//****************************************************************************
//============================================================================
//    HEADERS
//============================================================================
#include "mMatrix.h"

//============================================================================
//    PRIVATE DEFINITIONS / ENUMERATIONS / SIMPLE TYPEDEFS
//============================================================================

//============================================================================
//    PRIVATE STRUCTURES / UTILITY CLASSES
//============================================================================

//============================================================================
//    PRIVATE DATA
//============================================================================

//============================================================================
//    PRIVATE FUNCTIONS
//============================================================================

//============================================================================
//    FUNCTIONS
//============================================================================

//============================================================================
//    CLASS METHODS
//============================================================================

//=============================================================
// mMatrix::set
void mMatrix::set(const mMatrix& src)
{
  for (int i = 0; i < 15;)
  {
    m[i] = src.m[i]; i++;
    m[i] = src.m[i]; i++;
    m[i] = src.m[i]; i++;
    m[i] = src.m[i]; i++;
  }
}

//=============================================================
// mMatrix::makeIdentity
void mMatrix::makeIdentity()
{
  m[0] = 1.0f; m[4] = 0.0f; m[8]  = 0.0f; m[12] = 0.0f;
  m[1] = 0.0f; m[5] = 1.0f; m[9]  = 0.0f; m[13] = 0.0f;
  m[2] = 0.0f; m[6] = 0.0f; m[10] = 1.0f; m[14] = 0.0f;
  m[3] = 0.0f; m[7] = 0.0f; m[11] = 0.0f; m[15] = 1.0f;
}

//=============================================================
// mMatrix::mult
void mMatrix::mult(const mMatrix& a, const mMatrix& b)
{
  mMatrix m;

  m[0]=a[0]*b[0] + a[4]*b[1] + a[8 ]*b[2] + a[12]*b[3];
  m[1]=a[1]*b[0] + a[5]*b[1] + a[9 ]*b[2] + a[13]*b[3];
  m[2]=a[2]*b[0] + a[6]*b[1] + a[10]*b[2] + a[14]*b[3];
  m[3]=a[3]*b[0] + a[7]*b[1] + a[11]*b[2] + a[15]*b[3];

  m[4]=a[0]*b[4] + a[4]*b[5] + a[8 ]*b[6] + a[12]*b[7];
  m[5]=a[1]*b[4] + a[5]*b[5] + a[9 ]*b[6] + a[13]*b[7];
  m[6]=a[2]*b[4] + a[6]*b[5] + a[10]*b[6] + a[14]*b[7];
  m[7]=a[3]*b[4] + a[7]*b[5] + a[11]*b[6] + a[15]*b[7];

  m[8 ]=a[0]*b[8] + a[4]*b[9] + a[8 ]*b[10] + a[12]*b[11];
  m[9 ]=a[1]*b[8] + a[5]*b[9] + a[9 ]*b[10] + a[13]*b[11];
  m[10]=a[2]*b[8] + a[6]*b[9] + a[10]*b[10] + a[14]*b[11];
  m[11]=a[3]*b[8] + a[7]*b[9] + a[11]*b[10] + a[15]*b[11];

  m[12]=a[0]*b[12] + a[4]*b[13] + a[8 ]*b[14] + a[12]*b[15];
  m[13]=a[1]*b[12] + a[5]*b[13] + a[9 ]*b[14] + a[13]*b[15];
  m[14]=a[2]*b[12] + a[6]*b[13] + a[10]*b[14] + a[14]*b[15];
  m[15]=a[3]*b[12] + a[7]*b[13] + a[11]*b[14] + a[15]*b[15];

  set(m);
}

//****************************************************************************
//**    END MODULE mMatrix.cpp
//****************************************************************************

